﻿<!DOCTYPE html>

<!--
o Imports ships-data from the game "Pirates of the Caribbean" or it's mods
o Table has various display options, can be sorted, filtered and compared

(c) Stumpfl Markus
31.05.2016		Initial Release
09.06.2016		Added Periods, Bug fixing
10.06.2016		Added (simple) upload-restriction and file verification
11.06.2016		Get "Class" from MaxCrew
13.06.2016		Added Nations, Bug fixing
14.06.2016		Added Ingame Names via common.ini, convert encoding and other bug fixes
17.06.2016		Added the option to hide columns
22.06.2016		Several UI updates, info on ship specs and bug fixes
23.06.2016		Allowing to save & load a comparison incl. new sorting

http://www.stumpfl.at.tf/PotC-Ships
http://www.piratesahoy.net/threads/tool-to-create-ships-init-overview.27311

Tooltip: (c) http://www.walterzorn.com
-->

<html lang="en">
<head>
	<title>PotC - Ship Data Extraction Tool</title>
	<meta charset="utf-8">
	<meta http-equiv="Content-Script-Type" content="text/javascript">
	<meta http-equiv="Content-Style-Type" content="text/css">
	<link rel="icon" sizes="128x128" type="image/png" href="img/favicon.png">
	<link rel="prefetch" href="img/pageup.png">	
	<link rel="prefetch" href="img/nation_america.png">	
	<link rel="prefetch" href="img/nation_england.png">	
	<link rel="prefetch" href="img/nation_france.png">	
	<link rel="prefetch" href="img/nation_holland.png">	
	<link rel="prefetch" href="img/nation_pirate.png">	
	<link rel="prefetch" href="img/nation_portugal.png">	
	<link rel="prefetch" href="img/nation_spain.png">	
	<link rel="stylesheet" type="text/css" media="screen" href="style.css">
	<script type="text/javascript" src="functions.js"></script>
</head>
<body>
<?php
// Ask if the comparison table should be sorted:
if (!empty($_GET)&& !isset ($_GET["Sort"]))
	echo ('<script>AskToSort ();</script>');
?>

<script type="text/javascript" src="tooltip.js"></script>

<img class="top" alt="TOP" onclick="window.scrollTo(0,0);" src="img/pageup.png" onmouseover="Tip('Scroll to top');" onmouseout="UnTip();" />

<div id="Compare">
	<a href="#" onclick="UnTip(); ShowCompare();" onmouseover="Tip('Compare selected ships', ABOVE, true, OPACITY, 100);" onmouseout="UnTip();">COMPARE</a>
</div>

<?php
	$DataDir = 'data';
	
	$Include = array (
				"sname" => "Ingame Name",
				"class" => "Class",
				"capacity" => "Cargo",
				"hp" => "HP",
				"cannonsquantity" => "# Cannons",
				"maxcaliber" => "Max. Caliber",
				"mincrew" => "Min. Crew",
				"maxcrew" => "Max. Crew",
				"speedrate" => "Speedrate",
				"speedraterealism" => "Speed-Realism",
				"turnrate" => "Turnrate",
				"turnraterealism" => "Turn-Realism",
				"price" => "Price",
				"canencounter" => "Can Encounter?",			// alles vor "canencounter" wird zur Column-Auswahl hinzugefügt!
				"canbuy" => "Can Buy?",
				"period.0" => "Period 1",
				"period.1" => "Period 2",
				"period.2" => "Period 3",
				"period.3" => "Period 4",
				"period.4" => "Period 5",
				"period.5" => "Period 6",
				"england" => "England",
				"france" => "France",
				"holland" => "Holland",
				"portugal" => "Portugal",
				"spain" => "Spain",
				"america" => "America",
				"pirate" => "Pirates");
				
	$Exclude = array (
				"obj",
				"Boat",
				"Fort");
	
	$CrewToClassText = 'Armada: Ship Tier Mod';
	
	$CrewToClass = array (
				900,			// MaxCrew < 900 = Class 2
				550,			// 3
				400,
				250,
				100,
				60,
				30);
			
	$Classes = array (
				"- ALL -",
				"Class 1",
				"Class 2",
				"Class 3",
				"Class 4",
				"Class 5",
				"Class 6",
				"Class 7",
				"Class 8"
				);
				
	$Periods = array (
				"period" => array ("- ALL -", "Dont limit the time period"),
				"period.0" => array ("1500 - 1599", "Early Explorers"),
				"period.1" => array ("1600 - 1679", "Spanish Main"),
				"period.2" => array ("1680 - 1739", "Golden Age of Piracy"),
				"period.3" => array ("1740 - 1769", "Colonial Powers"),
				"period.4" => array ("1770 - 1789", "Revolutions"),
				"period.5" => array ("1790 - 1830", "Napoleonic")
				);
				
	$Nations = array (
				"england",
				"france",
				"holland",
				"portugal",
				"spain",
				"america",
				"pirate"
				);
				
	$ShipSpecifics = array (
				"&nbsp;" => array ("MaxCaliber", "Weight", "Capacity", "MaxCrew", "MinCrew", "SpeedRate", "TurnRate", "Price", "HP"),
				"English" => array (1.00, 0.95, 1.20, 0.95, 1.05, 1.05, 1.00, 1.10, 1.15),
				"French" => array (1.00, 1.00, 1.05, 1.15, 1.00, 1.05, 1.00, 1.05, 1.05),
				"Dutch" => array (1.00, 1.00, 1.30, 0.90, 1.00, 1.05, 0.95, 1.00, 1.00),
				"Portuguese" => array (1.00, 1.05, 1.20, 1.05, 1.00, 1.00, 1.15, 1.00, 0.95),
				"Spanish" => array (1.00, 1.15, 1.35, 1.05, 1.00, 0.95, 1.00, 1.05, 1.10),
				"United States" => array (1.00, 1.00, 1.10, 1.00, 1.05, 1.15, 1.00, 1.05, 1.10),
				"Pirate" => array (1.00, 0.90, 1.00, 1.05, 1.10, 1.10, 1.10, 0.95, 0.80)
				);
				
	$ColumnsToDisplay = false;
	
	require_once ('functions.php');
	
// *********************************************************************************
	
// Delete selected Datafile
	if (isset ($_POST["SelectObjectsChoice"]) && $_POST["SelectObjectsChoice"] == "delete")
	{
		global $DataDir;

		foreach ($_POST["Objects"] as $File)
		{
			if (!unlink ($DataDir.'/'.$File))
				echo ('<script type="text/javascript">alert ("Couldn\'t delete the file: ('.$File.')!");</script>');
		}

		DeletePost ();
	}
	
// Import New Ships-File
	if (isset ($_FILES["ShipData"]["tmp_name"]) && isset ($_FILES["ShipNames"]["tmp_name"]) && isset ($_POST["FileDesc"]))
	{
		ImportData ();
	}

// Check Data Files
	if (is_dir ($DataDir))
	{
		$handle = opendir($DataDir);
		$o = 0;
		while (false !== ($DataFiles[$o] = readdir($handle)))
		{
			if ($DataFiles[$o] != '.' && $DataFiles[$o] != '..')
				$o++;
		}
		closedir($handle);

		$DataFiles = array_slice ($DataFiles, 0, sizeof($DataFiles)-1);
		sort ($DataFiles);
	}
	else
		$DataFiles = array ();

// Load Shipsfile Form
	echo ('<h1>Pirates of the Caribbean - Ship Data Extraction Tool</h1>');

	echo ('<abbr onmouseover="Tip(\'<dl><dt>Load Data</dt><dd>locate the #Ships_init.c# and the #common.ini# files in the PotC directory</dd><dd>select them via the Load-Forms</dd><dd>click the #Load# button</dd><dd>to delete an imported file select it and click the #Delete# button (after activating it with the checkbox)</dd><dt>Sorting</dt><dd>#left-click# a header for primary sort</dd><dd>#right-click# for secondary sort</dd><dd>click again to switch ascending/descending</dd><dt>Display Options</dt><dd>select one or more imported data files</dd><dd>choose if ships that cannot be encountered/bought should be displayed</dd><dd>limit the output to a specific class of ships</dd><dd>limit the output to a specific nation</dd><dd>select which columns should be displayed</dd><dd>click the #Display# button</dd><dt>Comparing</dt><dd>click the row you want to add to the list</dd><dd>click again to remove it</dd><dd>click the #Compare# button to see the list</dd><dd>click the #Save# button to save this comparison for future use</dd><dd>when pasting this URL you will be asked if you want to keep the sorting (like the ships were added)<br/>&nbsp;&nbsp;&nbsp;&nbsp;or if the list should be sorted alphabetically (via ship names across all files!)</dd></dl>\', TITLE, \'HELP\', OPACITY, 100);" onmouseout="UnTip();">Help</abbr> ');
	
	echo ('# <abbr onmouseover="Tip(\'The ship data ingame can differ from these default values! More specifically:<dl><dt>Skills</dt><dd>I am not sure about this, but your skills (and your officers) might change the specs shown in the ships info panel</dd><dt>Upgrades</dt><dd>These really expensive upgrades have a direct impact on the ships performance and specs!</dd><dd>Especially <b>Reinforced Hull</b>, as this lets you buy bigger sized cannons!<br/>&nbsp;&nbsp;&nbsp;&nbsp;<i>-> a normal Frigate can accommodate 18 pounders; after this upgrade it fits 24 pounders!</i></dd><dt>Unique Ships</dt><dd>To get a unique ship, find <b>Hendrick Vanderdecken</b> in a <u>well known place</u> by getting a <u>well known object</u><br/>&nbsp;&nbsp;&nbsp;&nbsp;from a <u>well known character</u> in <u>another well known place</u>.</dd><dt>Nation Specific</dt><dd>Each nation has its own pros and cons:');
	echo ('<table class=help>');
	foreach ($ShipSpecifics as $Nation => $Data)
	{
		echo ('<tr><th>'.$Nation.'</th>');
		foreach ($Data as $Value)
		{
			if (is_numeric ($Value))
			{
				echo ('<td');
				if ($Value > 1)
					echo (" class=green");
				else if ($Value < 1)
					echo (" class=red");
				echo ('>'.number_format($Value, 2).'</td>');
			}
			else
				echo ('<td>'.$Value.'</td>');
		}
		echo ('</tr>');
	}
	echo ('</table>');
	echo ('</dd></dl>\', TITLE, \'Click to make sticky!\', OPACITY, 100, CLICKSTICKY, true, CLOSEBTN, true);" onmouseout="UnTip();">Differences in ingame data</abbr> ');
	
	if (sizeof ($DataFiles) == 0)
		echo ('<div id="loadfile" class="textshow">');
	else
	{
		echo ('# <abbr onmouseover="Tip(\'Click to hide/show the load-file-form!\', TITLE, \'INFO\');" onmouseout="UnTip();" onclick="ExpandCollapse(\'loadfile\');">Show/Hide Load-Form</abbr> ');
		echo ('# <abbr onmouseover="Tip(\'Click to hide/show the display-form!\', TITLE, \'INFO\');" onmouseout="UnTip();" onclick="ExpandCollapse(\'display\');">Show/Hide Display-Form</abbr>');
		echo ('<div id="loadfile" class="texthide">');
	}
	echo ('<form name="LoadFile" action="index.php" method="POST" enctype="multipart/form-data">');
		echo ('<p class="load">Please select the ships-file <span class="lowlight">(Ships_init.c)</span> and the names-file <span class="lowlight">(common.ini)</span>, as well as a description:<br/>');
		// ships_init.c
		echo ('<input type="file" class="fileupload" name="ShipData" multiple="false" size="50" maxlength="256" accept="text/*.c" onmouseover="Tip(\'Please select the ships-file from the filesystem! <i>(Ships_init.c)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		// common.ini
		echo ('<input type="file" class="fileupload" name="ShipNames" multiple="false" size="50" maxlength="256" accept="text/*.c" onmouseover="Tip(\'Please select the names-file from the filesystem! <i>(common.ini)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('<input type="text" class="filename" name="FileDesc" size="30" maxlength="30" onmouseover="Tip(\'Enter a description/headline for this data! <i>(eg. HorizonMod)</i>\', TITLE, \'Info\');" onmouseout="UnTip();" />');	
		echo ('<input type="button" class="load" Value=" Load " onclick="LoadFileCheck();" onmouseover="Tip(\'Load the selected ships-file.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('</p>');
	echo ('</form>');
	echo ('</div>');

	if (sizeof ($DataFiles) == 0)
	{
		echo ('<div class="nodata">no data yet</div>');
		exit ();
	}
	
	// Reset activated?
	if (isset ($_POST["ResetAll"]) && $_POST["ResetAll"] == "true")
		unset ($_POST);

	// Check POST for sort settings
	if (isset ($_POST["SortValue1"]) && $_POST["SortValue1"] != "")
	{
		if ($_POST["SortValue1"][0] == "-")
			$Sort1Type = "Desc";
		else
			$Sort1Type = "Asc";
		$Sort1 = substr ($_POST["SortValue1"], 1);
	}
	else
	{
		$Sort1 = "Name";
		$_POST["SortValue1"] = "+Name";
		$Sort1Type = "Asc";
	}
	
	if (isset ($_POST["SortValue2"]) && $_POST["SortValue2"] != "")
	{
		if ($_POST["SortValue2"][0] == "-")
			$Sort2Type = "Desc";
		else
			$Sort2Type = "Asc";
		$Sort2 = substr ($_POST["SortValue2"], 1);
	}
	else
	{
		$Sort2 = "";
		$_POST["SortValue2"] = "";
		$Sort2Type = "";
	}
	
	// Check POST for files to display
	if (!isset ($_POST["Objects"]) || $_POST["Objects"] == "")
		$_POST["Objects"][0] = $DataFiles[0];

	// Check POST for class filter
	if (!isset ($_POST["ShowClass"]) || $_POST["ShowClass"] == "")
		$ShowClass = 0;
	else
		$ShowClass = $_POST["ShowClass"];

	// Check POST for period filter
	if (!isset ($_POST["ShowPeriod"]) || $_POST["ShowPeriod"] == "")
		$ShowPeriod = "period";
	else
		$ShowPeriod = $_POST["ShowPeriod"];
	
	// Check POST for columns to display
	if (isset ($_POST["DisplayColumns"]))
		$ColumnsToDisplay = $_POST["DisplayColumns"];
	
	echo ('<div id="display" class="textshow">');
		// Display-Form
		echo ('<form name="SelectObjects" action="index.php" method="POST">');
		echo ('<input type="hidden" name="SelectObjectsChoice" size="30" maxlength="30" value="">');
		echo ('<input type="hidden" name="SortValue1" size="30" maxlength="30" value="'.$_POST["SortValue1"].'">');
		echo ('<input type="hidden" name="SortValue2" size="30" maxlength="30" value="'.$_POST["SortValue2"].'">');
		echo ('<table class="display" border="0">');
		echo ('<thead><tr><th onmouseover="Tip(\'Select the file(s) that should be displayed!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Files</th><th onmouseover="Tip(\'Select the filter(s) that should be applied!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Filter</th><th id="colspanheader" onmouseover="Tip(\'Select the column(s) that should be shown!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Columns</th><th>&nbsp;</th></tr></thead><tbody><tr>');
		echo ('<td class="one">');	// Files
			echo ('<select class="objects" id="Objects" name="Objects[]" size="5" multiple="multiple" onmouseover="Tip(\'<ul type=disc><li>Select single entries with >STRG<...</li><li>... multiple with >SHIFT<...</li><li>... and all entries wih >STRG + A<</li></ul>\', TITLE, \'Info\');" onmouseout="UnTip();">');

			foreach ($DataFiles as $DataFileName)
			{
				if (in_array ($DataFileName, $_POST["Objects"]))
					echo ('<option selected>'.$DataFileName.'</option>');
				else
					echo ('<option>'.$DataFileName.'</option>');
			}
			echo ('</select>');
		echo ('</td>');

		echo ('<td class="two">');		// Filter
			echo ('Cannot Encounter: <input type="checkbox" class="checkbox" onmouseover="Tip(\'Show ships that cannot be encountered?\', TITLE, \'Info\');" onmouseout="UnTip();" ');
			if (!isset ($_POST["ShowCanEncounter"]) || $_POST["ShowCanEncounter"] == "true")
			{
				echo ('id="ShowCanEncounter" name="ShowCanEncounter" value="true" checked><br/>');
				$ShowCanEncounter = true;
			}
			else
			{
				echo ('id="ShowCanEncounter" name="ShowCanEncounter" value="true"><br/>');
				$ShowCanEncounter = false;
			}
			echo ('<input type="hidden" id="ShowCanEncounterHidden" name="ShowCanEncounter" value="false">');	// wird benötigt zum Übertragen des "no checked" Values!
			
			echo ('Cannot Buy: <input type="checkbox" class="checkbox" onmouseover="Tip(\'Show ships that cannot be bought?\', TITLE, \'Info\');" onmouseout="UnTip();" ');
			if (!isset ($_POST["ShowCanBuy"]) || $_POST["ShowCanBuy"] == "true")
			{
				echo ('id="ShowCanBuy" name="ShowCanBuy" value="true" checked><br/>');
				$ShowCanBuy = true;
			}
			else
			{
				echo ('id="ShowCanBuy" name="ShowCanBuy" value="true"><br/>');
				$ShowCanBuy = false;
			}
			echo ('<input type="hidden" id="ShowCanBuyHidden" name="ShowCanBuy" value="false">');	// wird benötigt zum Übertragen des "no checked" Values!
			
			echo ('Class: <select name="ShowClass" class="dropdown" nchange="DisplayObject();" onmouseover="Tip(\'Select the class the list should be limited to.\', TITLE, \'Info\');" onmouseout="UnTip();">');
				for ($i=0; $i<sizeof ($Classes); $i++)
				{
					echo ('<option value="'.$i.'"');
					if ($ShowClass == $i)
						echo (' selected');
					echo ('>'.$Classes[$i].'</option>');
				}
			echo ('</select><br/>');
			
			echo ('Period: <select name="ShowPeriod" class="dropdown" nchange="DisplayObject();" onmouseover="Tip(\'Select the proper time period.\', TITLE, \'Info\');" onmouseout="UnTip();">');
				foreach ($Periods as $ID => $Value)
				{
					echo ('<option value="'.$ID.'"');
					if ($ShowPeriod == $ID)
						echo (' selected');
					echo ('>'.$Periods[$ID][0].'</option>');
				}
			echo ('</select>');
		echo ('</td>');
		echo ('<td class="three">');		// Columns
			$i = 0;
			$Modulo = 4;
			$NumCols = 1;
			
			foreach ($Include as $Column => $ColumnName)
			{
				if (stristr ($Column, "period") != false)
					break;
				
				echo ($ColumnName.': <input type="checkbox" class="checkbox" name="DisplayColumns[]"');
				if ($ColumnsToDisplay === false || in_array ($Column, $ColumnsToDisplay))
					echo ('checked ');
				echo ('value="'.$Column.'" onmouseover="Tip(\'Displays this column if enabled!\');" onmouseout="UnTip();" /><br/>');
				
				$i++;
				
				if (($i%$Modulo) == 0)
				{
					echo ('</td><td class="three">');
					$NumCols++;
				}
			}
			$i += 2;
			echo ('Periods: <input type="checkbox" class="checkbox" name="DisplayColumns[]"');
			if ($ColumnsToDisplay === false || in_array ("period", $ColumnsToDisplay))
				echo ('checked ');
			echo ('value="period" onmouseover="Tip(\'Displays this column if enabled!\');" onmouseout="UnTip();" /><br/>');
			if (($i%$Modulo) == 1)
			{
				echo ('</td><td class="three">');
				$NumCols++;
			}
			echo ('Nations: <input type="checkbox" class="checkbox" name="DisplayColumns[]"');
			if ($ColumnsToDisplay === false || in_array ("nation", $ColumnsToDisplay))
				echo ('checked ');
			echo ('value="nation" onmouseover="Tip(\'Displays this column if enabled!\');" onmouseout="UnTip();" /><br/>');
			// Update header colspan			
			echo ('<script>document.getElementById("colspanheader").colSpan = "'.$NumCols.'";</script>');
			// Needed to be able to reset the form via JS
			echo ('<input type="hidden" name="ResetAll" value="false">');
		echo ('</td>');
		echo ('<td class="four">');
			echo ('<input type="button" class="button" value="  Display  " onclick="DisplayObject();" onmouseover="Tip(\'Display the selected entries.\', TITLE, \'Info\');" onmouseout="UnTip();" /><br/>');
			echo ('<input type="button" class="buttondis" name="DelObj" disabled value="   Delete   " onclick="DeleteObject();" onmouseover="Tip(\'Delete the <u>selected</u> entries.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
			echo ('<input type="checkbox" class="checkbox" name="DelObjCheck" value="delete" onclick="DeleteObjectCheck();" onmouseover="Tip(\'Enable/Disable the <i>Delete</i>-Button.\', TITLE, \'Info\');" onmouseout="UnTip();" /><br/>');
			echo ('<input type="button" class="button" name="ResetDisplay" value="   Reset   " onclick="DelPost();" onmouseover="Tip(\'Clear the display options.\', TITLE, \'Info\');" onmouseout="UnTip();" />');
		echo ('</td>');
		echo ('</tr></tbody></table></form>');
	echo ('</div>');


// Show Content
	foreach ($_POST["Objects"] as $Selected)
	{
		$Data = LoadData ($Selected);

		if ($Sort2 == "")
			$Data = SortDataBy ($Data, $_POST["SortValue1"]);
		else
			$Data = SortDataBy ($Data, $_POST["SortValue1"], $_POST["SortValue2"]);
		
		echo ('<h2>'.$Selected.'</h2>');
		
		echo ('<table class="ships">');

		// Headers
		echo ('<thead><tr id="Header" class="header">');
			if ($Sort1 == "Name")
				echo ('<td id="highlighted1" class="'.$Sort1Type.'" name="Name" onclick="DisplayObject (this, \'\');" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			else if ($Sort2 == "Name")
				echo ('<td id="highlighted2" class="'.$Sort2Type.'" name="Name" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			else
				echo ('<td class="clickable" name="Name" onclick="DisplayObject (this, \'\');" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Leftclick: primary sorting column<br/>Rightclick: secondary sorting column\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">Name</td>');
			
			foreach ($Include as $Type => $TypeName)
			{
				if ($ColumnsToDisplay === false || in_array ($Type, $ColumnsToDisplay) || (stristr ($Type, "period") != false && in_array ("period", $ColumnsToDisplay)) || (in_array ($Type, $Nations) && in_array ("nation", $ColumnsToDisplay)))
				{
					if (stristr ($Type, "period") != false)
					{
						if ($ShowPeriod == "period" || $ShowPeriod == $Type)
							echo ('<td onmouseover="Tip(\''.$Periods[$Type][1].'\', DURATION, 2000, OPACITY, 100, TITLE, \''.$Periods[$Type][0].'\');" onmouseout="UnTip();">'.$TypeName.'</td>');
					}
					else if (in_array ($Type, $Nations))
					{
						echo ('<td onmouseover="Tip(\'<img src=img/nation_'.$Type.'.png width=150 />\', DURATION, 2000, OPACITY, 100, WIDTH, 150);" onmouseout="UnTip();">'.$TypeName.'</td>');
					}
					else
					{
						if ($Type == $Sort1)
							echo ('<td id="highlighted1" class="'.$Sort1Type.'" name="'.$Type.'" onclick="DisplayObject (this, \'\');" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
						else if ($Type == $Sort2)
							echo ('<td id="highlighted2" class="'.$Sort2Type.'" name="'.$Type.'" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Click again to switch ascending/descending order!\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
						else
							echo ('<td class="clickable" name="'.$Type.'" onclick="DisplayObject (this, \'\');" oncontextmenu="DisplayObject (\'\', this); return false;" onmouseover="Tip(\'Leftclick: primary sorting column<br/>Rightclick: secondary sorting column\', DURATION, 2000, OPACITY, 100);" onmouseout="UnTip();">'.$TypeName.'</td>');
					}
				}
			}
		echo ('</thead></tr><tbody>');
		
		// Data
		foreach ($Data as $ShipName => $ShipData)
		{
			if (($ShowCanEncounter == true || $ShipData["canencounter"] != "false") && ($ShowCanBuy == true || $ShipData["canbuy"] != "false") && ($ShowClass == 0 || $ShowClass == $ShipData['class']) && ($ShowPeriod == "period" || (array_key_exists ($ShowPeriod, $ShipData) && $ShipData[$ShowPeriod] > 0)))
			{
				// Daten des Schiffes gleich ausgeben wie "Header"
				$ShipData = array_merge (array_fill_keys (array_keys ($Include), ''), $ShipData);
				
				echo ('<tr class="highlight" onclick="SwitchCompare (this, \''.$Selected.'\')"><th>'.$ShipName.'</th>');
				foreach ($ShipData as $Key => $Value)
				{
					if ($ColumnsToDisplay === false || in_array ($Key, $ColumnsToDisplay) || (stristr ($Key, "period") != false && in_array ("period", $ColumnsToDisplay)) || (in_array ($Key, $Nations) && in_array ("nation", $ColumnsToDisplay)))
					{
						if (stripos ($Key, "period") !== false)
						{
							if ($ShowPeriod == "period" || $ShowPeriod == $Key)
							{
								if ($Value == 0)
									echo ('<td style="color:gray;">-</td>');
								else
								{
									$Value = $Value * 100;
									echo ('<td onmouseover="Tip(\''.$Periods[$Key][1].'\', DURATION, 1300, OPACITY, 100, TITLE, \''.$Periods[$Key][0].'\');" onmouseout="UnTip();">'.$Value.'%</td>');
								}
							}
						}
						else if (in_array ($Key, $Nations))
						{
							if ($Value == '' || $Value == 0)
								echo ('<td style="color:gray;">-</td>');
							else
							{
								$Value = $Value * 100;
								echo ('<td onmouseover="Tip(\'<img src=img/nation_'.$Key.'.png width=75 />\', DURATION, 1300, OPACITY, 100, WIDTH, 75, TITLE, \''.$Include[$Key].'\');" onmouseout="UnTip();">'.$Value.'%</td>');
							}
						}
						else if ($Key == "canencounter")
						{
							if ($ShowCanEncounter == true)
								echo ('<td onmouseover="Tip(\''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">'.(($Value=="true")?"Yes":"No").'</td>');
						}
						else if ($Key == "canbuy")
						{
							if ($ShowCanBuy == true)
								echo ('<td onmouseover="Tip(\''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">'.(($Value=="true")?"Yes":"No").'</td>');
						}
						else if ($Value == '')
							echo ('<td style="color:gray;">-</td>');
						else
							echo ('<td onmouseover="Tip(\''.$Include[$Key].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">'.mb_convert_encoding  ($Value, "UTF-8", "ASCII").'</td>');
					}
				}
				echo ('</tr>');
			}
		}
		echo ('</tbody></table>');
	}

	
// Compare TABLE (empty)
	echo ('<div id="DivCompare">');
		echo ('<h2>Comparison</h2>');
		
		echo ('<table class="ships" id="TableCompare">');
		
		// Show Saved Comparison
		if (!empty($_GET))
		{
			ShowSavedCompare ($_GET);
		}
			
		echo ('</table><div>');
		echo ('<span onclick="SaveCompare();" onmouseover="Tip(\'Click to save the comparison (by URL)!\');" onmouseout="UnTip();">> save <</span>');		
		echo ('<span onclick="HideCompare();" onmouseover="Tip(\'Click to hide comparison!\');" onmouseout="UnTip();">> close <</span>');		
	echo ('</div></div>');
	?>
</body>
</html>
